// 
// /////////////////////////////////////////////////////////////////////////////
// 
//     File Name:  dll_osc_r1.0.v
//       Version:  1.0
//          Date:  22.02.2008
//         Model:  Martin Kellermann
// 
//       Company:  Xilinx, Inc.
//   Contributor:  
// 
//    Disclaimer:  XILINX IS PROVIDING THIS DESIGN, CODE, OR
//                 INFORMATION "AS IS" SOLELY FOR USE IN DEVELOPING
//                 PROGRAMS AND SOLUTIONS FOR XILINX DEVICES.  BY
//                 PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
//                 ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
//                 APPLICATION OR STANDARD, XILINX IS MAKING NO
//                 REPRESENTATION THAT THIS IMPLEMENTATION IS FREE
//                 FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE
//                 RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY
//                 REQUIRE FOR YOUR IMPLEMENTATION.  XILINX
//                 EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH
//                 RESPECT TO THE ADEQUACY OF THE IMPLEMENTATION,
//                 INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//                 REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE
//                 FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES
//                 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//                 PURPOSE.
// 
//                 (c) Copyright 2008 Xilinx, Inc.
//                 All rights reserved.
// 
// /////////////////////////////////////////////////////////////////////////////
//  
//  Summary:
//   This module forwards a clock out of the FPGA using the DDR Flipflops
//   in the IO-cells.
// 
// --------------------------------------------------------------------------------
`timescale 1ns / 1ps
module clk_out (
input CLK,
output CLK_O_P,
output CLK_O_N);
 
wire    clk_o; 

ODDR clk_ddrff (.Q(clk_o),
          .C(CLK),
          .CE(1'b 1),
          .D1(1'b 1),
          .D2(1'b 0),
          .R(1'b 0),
          .S(1'b 0));
					
OBUFDS diff_o (.I(clk_o),
          .O(CLK_O_P),
          .OB(CLK_O_N));

endmodule // module clk_out

