// 
// /////////////////////////////////////////////////////////////////////////////
// 
//     File Name:  dll_ctrl_r1.0.v
//       Version:  1.0
//          Date:  22.02.2008
//         Model:  
// 
//       Company:  Xilinx, Inc.
//   Contributor:  Martin Kellermann
// 
//    Disclaimer:  XILINX IS PROVIDING THIS DESIGN, CODE, OR
//                 INFORMATION "AS IS" SOLELY FOR USE IN DEVELOPING
//                 PROGRAMS AND SOLUTIONS FOR XILINX DEVICES.  BY
//                 PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
//                 ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
//                 APPLICATION OR STANDARD, XILINX IS MAKING NO
//                 REPRESENTATION THAT THIS IMPLEMENTATION IS FREE
//                 FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE
//                 RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY
//                 REQUIRE FOR YOUR IMPLEMENTATION.  XILINX
//                 EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH
//                 RESPECT TO THE ADEQUACY OF THE IMPLEMENTATION,
//                 INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//                 REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE
//                 FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES
//                 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//                 PURPOSE.
// 
//                 (c) Copyright 2008 Xilinx, Inc.
//                 All rights reserved.
// 
// /////////////////////////////////////////////////////////////////////////////
//  
//  Summary:
//   This module instantiates the IDELAYCTRL-component and a primitive
//   support-system. This module is used alternatively to the one buried
//   in the design hierarchy.
// --------------------------------------------------------------------------------
`timescale 1ns / 1ps
module DLY_CTRL (
input CLK_200M_P,
input CLK_200M_N,
input RESET,
output RDY);
 
wire    refclk_200M_i; 
wire    refclk_200M; 
reg     [4:0] rst_cnt;// = 0; 
reg     rst_dly_ctrl;// = 1'b 1; 

initial begin
	rst_cnt = 0;
	rst_dly_ctrl = 1'b 1;
end

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//  IDELAY_CTRL and its life-support system
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

IBUFDS ref200 (.I(CLK_200M_P),
          .IB(CLK_200M_N),
          .O(refclk_200M_i));
BUFG ref200_bufg (.I(refclk_200M_i),
          .O(refclk_200M));

IDELAYCTRL dlyctrl (.RDY(RDY),
          .REFCLK(refclk_200M),
          .RST(rst_dly_ctrl));

always @(posedge refclk_200M)
   begin : process_1
   if (refclk_200M === 1'b 1)
      begin
      if (RESET === 1'b 1)
         begin
         rst_cnt <= {5{1'b 0}};   
         rst_dly_ctrl <= 1'b 1;   
         end
      else
         begin
         if (rst_cnt === 5'b 11110 | rst_cnt === 5'b 11111)
            begin
            rst_dly_ctrl <= 1'b 0;   
            end
         else
            begin
            rst_cnt <= rst_cnt + 1'b 1;   
            rst_dly_ctrl <= 1'b 1;   
            end
         end
      end
   end


endmodule 
