//
///////////////////////////////////////////////////////////////////////////////
//
//    File Name:  prbs_5_2v7_x7_x6_r1.0.v
//      Version:  1.0
//         Date:  22.02.2008
//        Model:  
//
//      Company:  Xilinx, Inc.
//  Contributor:  Martin Kellermann
//
//   Disclaimer:  XILINX IS PROVIDING THIS DESIGN, CODE, OR
//                INFORMATION "AS IS" SOLELY FOR USE IN DEVELOPING
//                PROGRAMS AND SOLUTIONS FOR XILINX DEVICES.  BY
//                PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
//                ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
//                APPLICATION OR STANDARD, XILINX IS MAKING NO
//                REPRESENTATION THAT THIS IMPLEMENTATION IS FREE
//                FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE
//                RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY
//                REQUIRE FOR YOUR IMPLEMENTATION.  XILINX
//                EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH
//                RESPECT TO THE ADEQUACY OF THE IMPLEMENTATION,
//                INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//                REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE
//                FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES
//                OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//                PURPOSE.
//
//                (c) Copyright 2008 Xilinx, Inc.
//                All rights reserved.
//
///////////////////////////////////////////////////////////////////////////////
// 
// Summary:
//
// 5-bit Parallel PRBS Generator for 2^7-1 with feedback of X7 + X6
//
// Initial seed is all ones
//
// Data must be sent MSB to LSB to match a standard PRBS pattern
//
// This VHDL code was automatically generated using prbs_gen version 1.8 - 04/09/2003
//
//
//--------------------------------------------------------------------------------
`timescale 1ns / 1ps
module prbs_5_2v7_x7_x6(
input CE,
input RST,
input CLK,
output [4:0] Q
);



reg [12:1] PRBS;// = 12'b 111111100000;

initial begin
	PRBS = 12'b 111111100000;
end


  assign Q = PRBS[12:8] ;
  always @(posedge CLK) begin
    if((RST == 1'b 1)) begin
      PRBS[12:1]  <= 12'b 111111100000;
    end
    else if((CE == 1'b 1)) begin
      PRBS[12]  <= PRBS[7] ;
      PRBS[11]  <= PRBS[6] ;
      PRBS[10]  <= PRBS[5] ;
      PRBS[9]  <= PRBS[4] ;
      PRBS[8]  <= PRBS[3] ;
      PRBS[7]  <= PRBS[2] ;
      PRBS[6]  <= PRBS[1] ;
      PRBS[5]  <= PRBS[6]  ^ PRBS[7] ;
      PRBS[4]  <= PRBS[5]  ^ PRBS[6] ;
      PRBS[3]  <= PRBS[4]  ^ PRBS[5] ;
      PRBS[2]  <= PRBS[3]  ^ PRBS[4] ;
      PRBS[1]  <= PRBS[2]  ^ PRBS[3] ;
    end
  end


endmodule
