
///////////////////////////////////////////////////////////////////////////////
//
//    File Name:  tb_io_dll_top.v
//      Version:  1.0
//         Date:  22.02.2008
//        Model:  
//
//      Company:  Xilinx, Inc.
//  Contributor:  Martin Kellermann
//
//   Disclaimer:  XILINX IS PROVIDING THIS DESIGN, CODE, OR
//                INFORMATION "AS IS" SOLELY FOR USE IN DEVELOPING
//                PROGRAMS AND SOLUTIONS FOR XILINX DEVICES.  BY
//                PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
//                ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
//                APPLICATION OR STANDARD, XILINX IS MAKING NO
//                REPRESENTATION THAT THIS IMPLEMENTATION IS FREE
//                FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE
//                RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY
//                REQUIRE FOR YOUR IMPLEMENTATION.  XILINX
//                EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH
//                RESPECT TO THE ADEQUACY OF THE IMPLEMENTATION,
//                INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//                REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE
//                FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES
//                OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//                PURPOSE.
//
//                (c) Copyright 2008 Xilinx, Inc.
//                All rights reserved.
//
///////////////////////////////////////////////////////////////////////////////
`timescale 1ns / 1ps
module tb_io_dll_top;

	// Inputs
	reg REFCLK_P = 1'b 1;
	reg REFCLK_N = 1'b 0;
	reg CLK_200M_P = 1'b 1;
	reg CLK_200M_N = 1'b 0;
	reg IDLAYCTRLRESET = 1'b 0;
	reg JITTERED_CLOCK = 1'b 0;
	reg RESET = 1'b 0;

	// Outputs
	wire CLKDLL_OUT_SMA_P;
	wire CLKDLL_OUT_SMA_N;
	wire CLKDLL_OUT_PIN_P;
	wire CLKDLL_OUT_PIN_N;
	wire CLKREF_OUT_P;
	wire CLKREF_OUT_N;
	wire IDLAYRDY;
	wire ERROR;
	wire [5:0] TOGGLE;
	wire LOCK_DCM;
	wire LOCK_DLL;


	always begin
		CLK_200M_P = 1'b0;
		#2.5 CLK_200M_P = 1'b1;
		#2.5;
	end  
	always @(CLK_200M_P)
	begin
		CLK_200M_N <= ! CLK_200M_P;
	end
	
	always begin
		REFCLK_P = 1'b0;
		#8 REFCLK_P = 1'b1;
		#8;
	end  
	always @(REFCLK_P)
	begin
		REFCLK_N <= ! REFCLK_P;
	end


  
	// Instantiate the Unit Under Test (UUT)
	io_dll_top #(
		.DLL_MULTIPLY(2),
		.TARGET_FREQUENCY(125))
	uut (
		.REFCLK_P(REFCLK_P), 
		.REFCLK_N(REFCLK_N), 
		.CLK_200M_P(CLK_200M_P), 
		.CLK_200M_N(CLK_200M_N), 
		.IDLAYCTRLRESET(IDLAYCTRLRESET), 
		.CLKDLL_OUT_SMA_P(CLKDLL_OUT_SMA_P), 
		.CLKDLL_OUT_SMA_N(CLKDLL_OUT_SMA_N), 
		.CLKDLL_OUT_PIN_P(CLKDLL_OUT_PIN_P), 
		.CLKDLL_OUT_PIN_N(CLKDLL_OUT_PIN_N), 
		.CLKREF_OUT_P(CLKREF_OUT_P), 
		.CLKREF_OUT_N(CLKREF_OUT_N), 
		.IDLAYRDY(IDLAYRDY), 
		.ERROR(ERROR), 
		.TOGGLE(TOGGLE), 
		.LOCK_DCM(LOCK_DCM), 
		.LOCK_DLL(LOCK_DLL), 
		.JITTERED_CLOCK(JITTERED_CLOCK), 
		.RESET(RESET)
	);
      
endmodule

