--
--/////////////////////////////////////////////////////////////////////////////
--
--    File Name:  dll_osc_r1.0.vhd
--      Version:  1.0
--         Date:  22.02.2008
--        Model:  
--
--      Company:  Xilinx, Inc.
--  Contributor:  
--
--   Disclaimer:  XILINX IS PROVIDING THIS DESIGN, CODE, OR
--                INFORMATION "AS IS" SOLELY FOR USE IN DEVELOPING
--                PROGRAMS AND SOLUTIONS FOR XILINX DEVICES.  BY
--                PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
--                ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
--                APPLICATION OR STANDARD, XILINX IS MAKING NO
--                REPRESENTATION THAT THIS IMPLEMENTATION IS FREE
--                FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE
--                RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY
--                REQUIRE FOR YOUR IMPLEMENTATION.  XILINX
--                EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH
--                RESPECT TO THE ADEQUACY OF THE IMPLEMENTATION,
--                INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
--                REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE
--                FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES
--                OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
--                PURPOSE.
--
--                (c) Copyright 2008 Xilinx, Inc.
--                All rights reserved.
--
--/////////////////////////////////////////////////////////////////////////////
-- 
-- Summary:
--  This module forwards a clock out of the FPGA using the DDR Flipflops
--  in the IO-cells.
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;

entity clk_out is
		Port ( CLK : in  STD_LOGIC;
					 CLK_O_P : out  STD_LOGIC;
					 CLK_O_N : out  STD_LOGIC);
end clk_out;

architecture Behavioral of clk_out is
	component ODDR port (
		Q : out std_logic;
		C : in std_logic;
		CE : in std_logic;
		D1 : in std_logic;
		D2 : in std_logic;
		R : in std_logic;
		S : in std_logic);
	end component;
	component obufds port(
		I: in std_logic;
		O: out std_logic;
		OB:out std_logic);
	end component;
	
	signal clk_o: std_logic;
begin
	clk_ddrff: ODDR port map (
		Q => clk_o,
		C => CLK,
		CE => '1',
		D1 => '1',
		D2 => '0',
		R => '0',
		S => '0');
	diff_o: obufds port map(
		I => clk_o,
		O => CLK_O_P,
		OB => CLK_O_N);

end Behavioral;
