--
--/////////////////////////////////////////////////////////////////////////////
--
--    File Name:  prbs_5_2v7_x7_x6_check_r1.0.vhd
--      Version:  1.0
--         Date:  22.02.2008
--        Model:  
--
--      Company:  Xilinx, Inc.
--  Contributor:  
--
--   Disclaimer:  XILINX IS PROVIDING THIS DESIGN, CODE, OR
--                INFORMATION "AS IS" SOLELY FOR USE IN DEVELOPING
--                PROGRAMS AND SOLUTIONS FOR XILINX DEVICES.  BY
--                PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
--                ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
--                APPLICATION OR STANDARD, XILINX IS MAKING NO
--                REPRESENTATION THAT THIS IMPLEMENTATION IS FREE
--                FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE
--                RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY
--                REQUIRE FOR YOUR IMPLEMENTATION.  XILINX
--                EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH
--                RESPECT TO THE ADEQUACY OF THE IMPLEMENTATION,
--                INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
--                REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE
--                FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES
--                OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
--                PURPOSE.
--
--                (c) Copyright 2008 Xilinx, Inc.
--                All rights reserved.
--
--/////////////////////////////////////////////////////////////////////////////
-- 
--
-- 5-bit Parallel PRBS Checker for 2^7-1 with feedback of X7 + X6
--
-- Next expected PRBS-pattern is generated from incoming data
--
--
----------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity prbs_5_2v7_x7_x6_check is 
   port   (CE : in  std_logic;
            RST : in  std_logic;
            CLK : in  std_logic;
						ERROR : out std_logic;
            D : in std_logic_vector(4 downto 0));
end prbs_5_2v7_x7_x6_check;

architecture synth of prbs_5_2v7_x7_x6_check is
	signal next_prbs: std_logic_vector(12 downto 1):=(others=>'0');
  signal PRBS_current : std_logic_vector (4 downto 0);
	signal test_prbs: std_logic_vector(4 downto 0):=(others=>'0');
	signal incoming_prbs: std_logic_vector(4 downto 0):=(others=>'0');

  signal PRBS : std_logic_vector (12 downto 1);

begin
 	PRBS_current<=D;

  reg: process (CLK)
  begin
    if rising_edge(CLK) then
      if (RST = '1') then
        next_PRBS(12 downto 1) <= "111111100000";
      elsif (CE = '1') then
        next_PRBS(12) <= next_PRBS( 7);
        next_PRBS(11) <= next_PRBS( 6);
        next_PRBS(10) <= next_PRBS( 5);
        next_PRBS( 9) <= next_PRBS( 4);
        next_PRBS( 8) <= next_PRBS( 3);
        next_PRBS( 7) <= next_PRBS( 2);
        next_PRBS( 6) <= next_PRBS( 1);
        next_PRBS( 5) <= next_PRBS( 6) XOR next_PRBS( 7);
        next_PRBS( 4) <= next_PRBS( 5) XOR next_PRBS( 6);
        next_PRBS( 3) <= PRBS_current( 4) XOR next_PRBS( 5);
        next_PRBS( 2) <= PRBS_current( 3) XOR PRBS_current( 4);
        next_PRBS( 1) <= PRBS_current( 2) XOR PRBS_current( 3);

 				test_prbs(4 downto 1)<=	next_PRBS(4 downto 1);
				incoming_prbs<=PRBS_current;
      end if;                                 
    end if;
  end process reg;
	test_prbs(0)<= next_PRBS(5);

	process(CLK)
	begin
		if RST='1' then
			ERROR<='0';
		elsif rising_edge(CLK) then
			if incoming_prbs /= test_prbs then
				ERROR<='1';
			else
				ERROR<='0';
			end if;
		end if;
	end process;									


end synth;


