--
--/////////////////////////////////////////////////////////////////////////////
--
--    File Name:  prbs_5_2v7_x7_x6_r1.0.vhd
--      Version:  1.0
--         Date:  22.02.2008
--        Model:  
--
--      Company:  Xilinx, Inc.
--  Contributor:  
--
--   Disclaimer:  XILINX IS PROVIDING THIS DESIGN, CODE, OR
--                INFORMATION "AS IS" SOLELY FOR USE IN DEVELOPING
--                PROGRAMS AND SOLUTIONS FOR XILINX DEVICES.  BY
--                PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
--                ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
--                APPLICATION OR STANDARD, XILINX IS MAKING NO
--                REPRESENTATION THAT THIS IMPLEMENTATION IS FREE
--                FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE
--                RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY
--                REQUIRE FOR YOUR IMPLEMENTATION.  XILINX
--                EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH
--                RESPECT TO THE ADEQUACY OF THE IMPLEMENTATION,
--                INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
--                REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE
--                FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES
--                OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
--                PURPOSE.
--
--                (c) Copyright 2008 Xilinx, Inc.
--                All rights reserved.
--
--/////////////////////////////////////////////////////////////////////////////
-- 
-- Summary:
--
-- 5-bit Parallel PRBS Generator for 2^7-1 with feedback of X7 + X6
--
-- Initial seed is all ones
--
-- Data must be sent MSB to LSB to match a standard PRBS pattern
--
-- This VHDL code was automatically generated using prbs_gen version 1.8 - 04/09/2003
--
--
----------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity prbs_5_2v7_x7_x6 is 
   port   (CE : in  std_logic;
            RST : in  std_logic;
            CLK : in  std_logic;
            Q : out std_logic_vector(4 downto 0));
end prbs_5_2v7_x7_x6;

architecture synth of prbs_5_2v7_x7_x6 is

  signal PRBS : std_logic_vector (12 downto 1):="111111100000";

begin
  Q <= PRBS(12 downto 8);

  reg: process (CLK)
  begin
    if rising_edge(CLK) then
      if (RST = '1') then
        PRBS(12 downto 1) <= "111111100000";
      elsif (CE = '1') then
        PRBS(12) <= PRBS( 7);
        PRBS(11) <= PRBS( 6);
        PRBS(10) <= PRBS( 5);
        PRBS( 9) <= PRBS( 4);
        PRBS( 8) <= PRBS( 3);
        PRBS( 7) <= PRBS( 2);
        PRBS( 6) <= PRBS( 1);
        PRBS( 5) <= PRBS( 6) XOR PRBS( 7);
        PRBS( 4) <= PRBS( 5) XOR PRBS( 6);
        PRBS( 3) <= PRBS( 4) XOR PRBS( 5);
        PRBS( 2) <= PRBS( 3) XOR PRBS( 4);
        PRBS( 1) <= PRBS( 2) XOR PRBS( 3);
      end if;
    end if;
  end process reg;
end synth;


