--
--/////////////////////////////////////////////////////////////////////////////
--
--    File Name:  tb_io_dll_top.vhd
--      Version:  1.0
--         Date:  22.02.2008
--        Model:  
--
--      Company:  Xilinx, Inc.
--  Contributor:  
--
--   Disclaimer:  XILINX IS PROVIDING THIS DESIGN, CODE, OR
--                INFORMATION "AS IS" SOLELY FOR USE IN DEVELOPING
--                PROGRAMS AND SOLUTIONS FOR XILINX DEVICES.  BY
--                PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
--                ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
--                APPLICATION OR STANDARD, XILINX IS MAKING NO
--                REPRESENTATION THAT THIS IMPLEMENTATION IS FREE
--                FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE
--                RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY
--                REQUIRE FOR YOUR IMPLEMENTATION.  XILINX
--                EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH
--                RESPECT TO THE ADEQUACY OF THE IMPLEMENTATION,
--                INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
--                REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE
--                FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES
--                OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
--                PURPOSE.
--
--                (c) Copyright 2008 Xilinx, Inc.
--                All rights reserved.
--
--/////////////////////////////////////////////////////////////////////////////

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY tb_io_dll_top IS
END tb_io_dll_top;

ARCHITECTURE behavior OF tb_io_dll_top IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT io_dll_top
	Generic( TARGET_FREQUENCY: integer range 10 to 250:=125;
					 DLL_MULTIPLY: integer range 1 to 32:=2
	);
	PORT(
		REFCLK_P : IN std_logic;
		REFCLK_N : IN std_logic;
		CLK_200M_p : IN std_logic;
		CLK_200M_n : IN std_logic;
		IDLAYCTRLRESET : IN std_logic;
		JITTERED_CLOCK : IN std_logic;
		RESET : IN std_logic;          
		CLKDLL_OUT_SMA_P : OUT std_logic;
		CLKDLL_OUT_SMA_N : OUT std_logic;
		CLKDLL_OUT_PIN_P : OUT std_logic;
		CLKDLL_OUT_PIN_N : OUT std_logic;
		CLKREF_OUT_P : OUT std_logic;
		CLKREF_OUT_N : OUT std_logic;
		IDLAYRDY : OUT std_logic;
		ERROR : OUT std_logic;
		TOGGLE : OUT std_logic_vector(5 downto 0);
		LOCK_DCM : OUT std_logic;
		LOCK_DLL : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL REFCLK_P :  std_logic := '1';
	SIGNAL REFCLK_N :  std_logic := '0';
	SIGNAL CLK_200M_p :  std_logic := '1';
	SIGNAL CLK_200M_n :  std_logic := '0';
	SIGNAL IDLAYCTRLRESET :  std_logic := '0';
	SIGNAL JITTERED_CLOCK :  std_logic := '0';
	SIGNAL RESET :  std_logic := '0';

	--Outputs
	SIGNAL CLKDLL_OUT_SMA_P :  std_logic;
	SIGNAL CLKDLL_OUT_SMA_N :  std_logic;
	SIGNAL CLKDLL_OUT_PIN_P :  std_logic;
	SIGNAL CLKDLL_OUT_PIN_N :  std_logic;
	SIGNAL CLKREF_OUT_P :  std_logic;
	SIGNAL CLKREF_OUT_N :  std_logic;
	SIGNAL IDLAYRDY :  std_logic;
	SIGNAL ERROR :  std_logic;
	SIGNAL TOGGLE :  std_logic_vector(5 downto 0);
	SIGNAL LOCK_DCM :  std_logic;
	SIGNAL LOCK_DLL :  std_logic;

BEGIN

	CLK_200M_p <= not CLK_200M_p after 2.5 ns;
	CLK_200M_n <= not CLK_200M_p;
	
	--REFCLK_P <= not REFCLK_P after 8 ns;
	--REFCLK_P <= not REFCLK_P after 4.1 ns;
	--REFCLK_P <= not REFCLK_P after 3.45 ns;
	--REFCLK_P <= not REFCLK_P after 6.9 ns;
	--REFCLK_P <= not REFCLK_P after 13.8 ns;
	--REFCLK_P <= not REFCLK_P after 27.6 ns;
	--REFCLK_P <= not REFCLK_P after 4.53 ns;
	--REFCLK_P <= not REFCLK_P after 33.3 ns;
	REFCLK_P <= not REFCLK_P after 8 ns;
	REFCLK_N <= not REFCLK_P;



	-- Instantiate the Unit Under Test (UUT)
	uut: io_dll_top PORT MAP(
		REFCLK_P => REFCLK_P,
		REFCLK_N => REFCLK_N,
		CLK_200M_p => CLK_200M_p,
		CLK_200M_n => CLK_200M_n,
		IDLAYCTRLRESET => IDLAYCTRLRESET,
		CLKDLL_OUT_SMA_P => CLKDLL_OUT_SMA_P,
		CLKDLL_OUT_SMA_N => CLKDLL_OUT_SMA_N,
		CLKDLL_OUT_PIN_P => CLKDLL_OUT_PIN_P,
		CLKDLL_OUT_PIN_N => CLKDLL_OUT_PIN_N,
		CLKREF_OUT_P => CLKREF_OUT_P,
		CLKREF_OUT_N => CLKREF_OUT_N,
		IDLAYRDY => IDLAYRDY,
		ERROR => ERROR,
		TOGGLE => TOGGLE,
		LOCK_DCM => LOCK_DCM,
		LOCK_DLL => LOCK_DLL,
		JITTERED_CLOCK => JITTERED_CLOCK,
		RESET => RESET
	);

END;
